-----------------------------------------------------------------------------
-- Demo unit test for iuptree2.wlua
-- Same test function 'new style' (all local variables)
-- @release 0.0.0
-----------------------------------------------------------------------------
local test = require('btd.lua.testapi')
local testIup = require('btd.lua.testiup')

TestIupTree2New = {}

function TestIupTree2New:setUp()
    dofile('iuptree2.wlua')
end

function TestIupTree2New:test_createNewStyle()
    local function idleLoop(t)
        return function()
            if (os.clock() - t) < 2 then return iup.DEFAULT else return iup.CLOSE end
        end
    end
    test.equals(tree.name0,'Animals')
    test.equals(tree.name1,'Mammals')
    test.equals(tree.name2,'Horse')
    test.equals(tree.name3,'Whale')
    test.equals(tree.name4,'Crustaceans')
    test.equals(tree.name5,'Shrimp')
    test.equals(tree.name6,'Lobster')
    test.equals(tree.state0,'EXPANDED')
    test.equals(tree.state1,'EXPANDED')
    test.equals(tree.state4,'EXPANDED')
    local t = os.clock() -- let's give ourselves 2 s to close the 'Crustaceans' branch
    testIup.iupLoop(idleLoop(t))
    test.equals(tree.state4,'COLLAPSED')
    test.fails(error,'an error')
end

